-- 每日充值
Lua_ChargeEverydayWindow = class("Lua_ChargeEverydayWindow", Lua_Window)
function Lua_ChargeEverydayWindow:ctor(p)
	self:superCall("ctor", p, "TodayChargePanel_skin");

	self.windowName = "Lua_ChargeEverydayWindow";
	self.skinName = "ChargeEverydayWindow_skin";
end

function Lua_ChargeEverydayWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);

	self.btnList = Lua_DragList.new(self.content ,2 , Vector4(0, 0, 622, 72));
	self.btnList:setListCell(Lua_ChargeEverydayBtnItem, 72, 183, 999);
	self.btnList:setLocation(-58, 103, 0);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(3);
	self.rItem:setLayout(124, 90, 3);
	self.rItem:setMaxShow(9);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setLocation(-148, 15);

	self.rechargeList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 343, 392));
	self.rechargeList:setListCell(Lua_ChargeEverydayRechargeItem, 138, 343, 1);
	self.rechargeList:setLocation(444.5, -15, 0);

	self.chargeBtn:addClickFuntion(self, self.onChargeClick);

	self:addLuaEvent("GET_REWARD_ITEM_INFORMATION", self, self.updateChargeEverydayInfo);
	self:addLuaEvent("CHARGE_TYPE_CLICK", self, self.setSelected);
	DataCenter.todayChargeData:sGetRewardItemInfomation();
end

function Lua_ChargeEverydayWindow:updateChargeEverydayInfo(val)
	self.data = val;

	local arr = DataCenter.todayChargeData.todayLeichongRewardList;
	local toIdx = 1;
	for i = 1, arr:getSize() do
		if arr[i].state == 1 or arr[i].state == 0 then
			toIdx = i;
			break;
		end
	end
	self.btnList:setLuaArrayData(arr, false);
	self.btnList:moveToIndex(toIdx, true);
	self.btnList:setSelected(toIdx);
	self:setSelected(arr[toIdx]);

	self.rechargeList:setLuaArrayData(DataCenter.todayChargeData.leichongList, false);
	self.curChargeTxt.text = LanUtil.formateStr(LanUtil.getValue(122540), tostring(val.today_recharge))
end

function Lua_ChargeEverydayWindow:setSelected(btnItemInfo)
	self:showRewardInfo(btnItemInfo.id);
	
	if btnItemInfo.state == 1 then
		self.chargeBtn.label = LanUtil.getValue(121916);
	elseif btnItemInfo.state == 0 then
		self.chargeBtn.label = LanUtil.getValue(122513);
	elseif btnItemInfo.state == 2 then
		self.chargeBtn.label = LanUtil.getValue(122528);
	end
	self.chargeBtn:setBtnEnable(btnItemInfo.state ~= 2);
	self.redDot:setEnable(btnItemInfo.state == 1);
end

function Lua_ChargeEverydayWindow:showRewardInfo(showId)
	if self.showRewardId == showId then
		return;
	end
	self.showRewardId = showId;

	local effIdList = self.data.effect_item_list[showId].value_list;
	local effIdDic = {};
	for i = 1, #effIdList do
		effIdDic[effIdList[i]] = 1;
	end

	local rewardId = self.data.reward_list[showId];
	self.rItem:setRewardByRewardList(Array(rewardId));
	
	local rewardInfo = Lua_RewardsUtil.getRewardList(rewardId);
	local tvoArr = rewardInfo.rewardsVoArr;
	for i = 1, tvoArr:getSize() do
		self.rItem:getToolImageById(tvoArr[i].id):showRoundEff(effIdDic[tvoArr[i].id] == 1);
	end
end

function Lua_ChargeEverydayWindow:onChargeClick(go)
	local arr = DataCenter.todayChargeData.todayLeichongRewardList;
	if arr:getSize() > 0 then
		if arr[self.showRewardId].state == 1 then
			DataCenter.todayChargeData:sGetTodayReward(tonumber(self.showRewardId - 1))
		else
			Lua_WindowUtil.openWin("Lua_ChongzhiWindow")
			Lua_WindowUtil.openWin("Lua_ChargeEverydayWindow", WinParam.ACTION_CLOSE, nil)
		end
	end
end

function Lua_ChargeEverydayWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.rechargeList ~= nil then
		self.rechargeList:dispose();
		self.rechargeList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_ChargeEverydayBtnItem = class("Lua_ChargeEverydayBtnItem", Lua_ListCell)
function Lua_ChargeEverydayBtnItem:ctor(p)
	self:superCall("ctor", p, "ChargeEverydayBtnItem_skin");
end

function Lua_ChargeEverydayBtnItem:buildShowItem()
	self:superCall("buildShowItem");

	self.redDot:setEnable(false);
end

function Lua_ChargeEverydayBtnItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.numberTxt.text = LanUtil.formateStr(LanUtil.getValue(122542), tostring(data.need_gold));
    self.redDot:setEnable(data.state == 1)
end

function Lua_ChargeEverydayBtnItem:onPlayerSoundClick(go)
    Lua_MsgUtil.callFunc("CHARGE_TYPE_CLICK", self._data);
end

function Lua_ChargeEverydayBtnItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);
	self.selectSp:setEnable(val);
	self.numberTxt.colorStr = Lua_ColorDefine.transColor(val and "DDF0F9" or "CAE6FE");
end

function Lua_ChargeEverydayBtnItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ChargeEverydayRechargeItem = class("Lua_ChargeEverydayRechargeItem", Lua_ListCell)
function Lua_ChargeEverydayRechargeItem:ctor(p)
	self:superCall("ctor", p, "ChargeEverydayRechargeItem_skin");
end

function Lua_ChargeEverydayRechargeItem:buildShowItem()
	self:superCall("buildShowItem");

	self.effectList = Array();

	self.redDot:setEnable(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setDepth(3);
	self.rItem:setMaxShow(2);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.9, 0.9);
	self.rItem:setLocation(-119, -17);

	self.getBtn:addClickFuntion(self, self.onGetClick);
end

function Lua_ChargeEverydayRechargeItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	if data.days >= data.count then
		self.chargeTxt.text = LanUtil.formateStr(LanUtil.getValue(122515), tostring(data.count), tostring(data.days), tostring(data.count), tostring(data.sum));
	else
		self.chargeTxt.text = LanUtil.formateStr(LanUtil.getValue(122541), tostring(data.count), tostring(data.days), tostring(data.count), tostring(data.sum));
	end

	if data.state == 0 then
		self.getBtn.label = LanUtil.getValue(122516);
		self.getBtn:setBtnEnable(false);
		self.redDot:setEnable(false);
	elseif data.state == 1 then
		self.getBtn.label = LanUtil.getValue(122516);
		self.getBtn:setBtnEnable(true);
		self.redDot:setEnable(true);
	elseif data.state == 2 then
		self.getBtn.label = LanUtil.getValue(110029);
		self.getBtn:setBtnEnable(false);
		self.redDot:setEnable(false);
	end
	self.rItem:setRewardByRewardList(Array(data.rewards));

	local rewardConfig = Lua_RewardsUtil.getRewardList(data.rewards);
	local len = rewardConfig.rewardsVoArr:getSize();
	local toolImg;
	for i = 1, len do
		if data.effectId ~= nil then
			for j = 1, #data.effectId.value_list do
				if rewardConfig.rewardsVoArr[i].id == data.effectId.value_list[j] then
					toolImg = self.rItem:getToolImageById(rewardConfig.rewardsVoArr[i].id);
					toolImg:showRoundEff(true);
					self.effectList:add(toolImg);
				end
			end
		end
	end
end

function Lua_ChargeEverydayRechargeItem:checkOutBound(showRect)
	local rect = Lua_Rectangle.new(self.itemX - 35, self.itemY - 35, 70, 70);
	for i = 1, self.effectList:getSize() do
		self.effectList[i]:showRoundEff(showRect:containeRect(rect));
	end
end

function Lua_ChargeEverydayRechargeItem:onGetClick(go)
	DataCenter.todayChargeData:sGetSeveralDaysReward(self._data.id);
end

function Lua_ChargeEverydayRechargeItem:dispose()
	if self.rItem ~= nil then
		self.rItem:dispose();
		self.rItem = nil;
	end
	if self.effectList ~= nil then
		self.effectList:dispose();
		self.effectList:clear();
		self.effectList = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end